////////////////////////////////////////////////////////
// on-action code: time and other actions from loop() //
////////////////////////////////////////////////////////

#ifndef _MY_ST_ACTION_H_
#define _MY_ST_ACTION_H_

#include "myST_Gen.h"

//** add your own "on action" code **/
void onAction() {  // every minute called by loop()
  for (uint8_t i = 0; i < nItems; i++) {
    if (!atoi(itemValues[i][nPause]) && atoi(itemValues[i][nMode])) {  // NOT paused and mode > ZERO
      if (i == nScreen) {
        uint8_t s = atoi(itemValues[nScreen][nStatus]);
        if (s == 0) {  // screen is UP
          if (gemLux[0] > atoi(itemValues[nScreen][nLuxDown1]) && gemTmp[0] > atof(itemValues[nScreen][nTmpDown1])) yoyo++;  // temp AND lux positive?
          if (atoi(itemValues[nScreen][nYoYo1]) == yoyo) strcpy(itemValues[nScreen][nStatus], "1");  // set value to DOWN
        }
        else if (s == 1) {  // screen is DOWN
          if (gemLux[0] < atoi(itemValues[nScreen][nYoYo1]) || gemTmp[0] < atof(itemValues[nScreen][nTmpUp1])) yoyo++;  // temp OR lux negative?
          if (atoi(itemValues[nScreen][nYoYo1]) == yoyo) strcpy(itemValues[nScreen][nStatus], "0");  // set value to DOWN
        }
        else yoyo = 0;
        if (dayTime == (daySet - 900)) {  // always 15 minutes before SunSet screen-UP
          strcpy(itemValues[nScreen][nStatus], "0");
          screenDownUp(nScreen);
          if (s) saveIt = true;
        }
        else if (s != atoi(itemValues[nScreen][nStatus])) {
          screenDownUp(nScreen);
          saveIt = true;
        }
      }
      else if (i == nLampK1) {
        // USING TIME TEST: uint8_t timesTest(time_t testTime, time_t timeFrom, time_t timeTo, boolean between) return NO/OFF/ON
        // between false: if testTime is timeFrom return ON, if testTime is= timeTO return OFF, else return NO
        // between true:  if testTime is between timeFrom and timeTo return ON else return OFF
        uint8_t n0 = timesTest(dayTime, (atoi(itemValues[nLampK1][nOnHH2]) * 3600 + atoi(itemValues[nLampK1][nOnMM2]) * 60), (dayRise + atoi(itemValues[nLampK1][nRise2]) * 60), false);
        uint8_t n1 = timesTest(dayTime, (daySet - atoi(itemValues[nLampK1][nSet2]) * 60), (atoi(itemValues[nLampK1][nOffHH2]) * 3600 + atoi(itemValues[nLampK1][nOffMM2]) * 60), false);
        uint8_t m = atoi(itemValues[nLampK1][nMode]);  // mode: 1,2 or 3?
        if (n0 != NO && m == 1 || m == 3) strcpy(itemValues[nLampK1][nStatus], String(n0).c_str());  // n0: morning
        if (n1 != NO && m == 2 || m == 3) strcpy(itemValues[nLampK1][nStatus], String(n1).c_str());  // n1: evening
        if (n0 != NO || n1 != NO) {  
          kakuOffOn(nLampK1);
          saveIt = true;          
        }
      }
    }
  }
}

#endif
