/////////////////////////////////////////////////////////////////
// on-command code: commands from WebSocket and/or other Nodes //
/////////////////////////////////////////////////////////////////

#ifndef _MY_CMD_H_
#define _MY_CMD_H_

#include <myST_StdCmd.h>

/** add your own "on command" code **/
void onCommand() {  // called on received commands
  uint8_t done = 0;        // set if a standard command is done
  boolean ok =     false,  // if from WS then send OK:yes/no
          toWS =   false;  // from "|WS|"?
  strcpy(msg[0], now_msgQueue[--now_msgInQueue]);  // fifo ESP-NOW message
  if (strncmp(msg[0], "|WS|", 4) == 0) {
    sendTo(msg[0]);
    return;
  }
  uint8_t n = parseFldVal(msg[0]);
  if (n >= 2) { // < 2:no data
    /** now the field names are in "cmd" and field values in "val" **/ 
    if(strcmp(valIn[0], "WS") == 0) toWS = true;
    done = stdCommands();  // standard ...   (1: stdCmd has send, 2: send a OK to WS
    if (!done) {                        // ...  or 0 a Item command?
      done = 2;
      if ((strcmp(itemNames[nHeat][0], fldIn[1]) + strcmp(itemValues[nHeat][0], valIn[1])) == 0) {  // function item "screen"?
        if ((n - 1) <= itemFields[nHeat]) {
          ok = true;
          for (uint8_t i = 2; i < n; i++) {
            for (uint8_t ii = nMode; ii < itemFields[nHeat]; ii++) {
              if (strcmp(fldIn[i], itemNames[nHeat][ii]) == 0) {
                strcpy(itemValues[nHeat][ii], valIn[i]);  // set new value
                if (strcmp(fldIn[i], itemNames[nHeat][nStatus]) == 0) heatOnOff(nHeat);
                saveIt = true;
              }
            }
          }
        }
      }
      else if (strcmp(fldIn[1], "CMD") == 0) {  // ##### aditional command(s) list #####
        // aditional command list:  "|me|from|CMD|<item number>|"
        if ((atoi(valIn[1]) - 1) == nHeat) {  // list aditional command(s)
          sprintf(msg[0], "|%s|%s%|%s|%s|%s|", valIn[0], now_Address, fldIn[1], itemValOrg[nHeat][nName], cmdList[nHeat]);
          sendTo(msg[0]);
          done = 1;
        }
      }
    }
    if (toWS && (done == 2)) {
      sprintf(msg[0], "|WS|%s|OK?|%s|", now_Address, (ok ? "YES" : "NO"));
      sendTo(msg[0]);
    }
  }
}

#endif
